.* Dokumentacja techniczna biblioteki okien kontrolnych asuactl.dll
.* opis struktur danych oglnego przeznaczenia
.*

.* Rozdzia 2 - Struktury danych oglnego przeznaczenia
.*
:h1 res=002.Struktury danych
:p.Rozdzia zawiera opis struktur danych uywanych przez okna kontrolne.


.* Rozdzia 2.1 - Struktury oglnego przenaczenia
.*
:h2 res=021.Struktury oglnego przenaczenia
:p.Rozdzia zawiera opis struktur danych dostpnych dla uytkownika,
z ktrych korzystaj okna kontrolne biblioteki asuactl.dll.


.* Struktura OWNERBACK
.*
:h3 name=OWNERBACK.OWNERBACK
:p.Struktura uywana jest podczas przetwarzania komunikatu WM_DRAWITEM,
i daje uytkownikowi moliwo przerysowania ta kontrolki.
:cgraphic.
typedef struct
{ HWND    :link dependent reftype=hd refid=OBK_HWND.hwnd:elink.;     // Uchwyt przerysowywanego okna
  HPS     :link dependent reftype=hd refid=OBK_HPS.hps:elink.;      // Uchwyt presentation space okna
  RECTL   :link dependent reftype=hd refid=OBK_BOUND.bound:elink.;    // Wsprzdne obszaru, ktry naley przerysowa
  POINTL  :link dependent reftype=hd refid=OBK_REFPOINT.refpoint:elink.; // Przesunicie ta wzgldem przerysowywanego obszaru
} OWNERBACK;
:ecgraphic.

.* Pole hwnd
.*
:h3 group=20 x=30% y=bottom width=70% height=225x hide name=OBK_HWND.OWNERBACK pole - hwnd
:dl tsize=3 break=all.
:dt.:hp2.hwnd:ehp2. (HWND)
:dd.Uchwyt przerysowywanego okna.
:edl.

.* Pole hps
.*
:h3 group=21 x=30% y=bottom width=70% height=225x hide name=OBK_HPS.OWNERBACK pole - hps
:dl tsize=3 break=all.
:dt.:hp2.hps:ehp2. (HPS)
:dd.Uchwyt presentation space, ktrej naley uy do rysowania wewntrz okna.
:edl.

.* Pole bound
.*
:h3 group=22 x=30% y=bottom width=70% height=225x hide name=OBK_BOUND.OWNERBACK pole - bound
:dl tsize=3 break=all.
:dt.:hp2.bound:ehp2. (RECTL)
:dd.Struktura :hp1.bound:ehp1. zawiera wsprzdne przerysowywanego obszaru
liczone wzgldem lewego dolnego rogu okna.
:edl.

.* Pole refpoint
.*
:h3 group=23 x=30% y=bottom width=70% height=225x hide name=OBK_REFPOINT.OWNERBACK pole - refpoint
:dl tsize=3 break=all.
:dt.:hp2.refpoint:ehp2. (POINTL)
:dd.Struktura :hp1.refpoint:ehp1. zawiera przesunicie, ktre trzeba doda do wsprzdnych
przekazanych w polu :hp1.bound:ehp1. - przesunity prostokt okrela
obszar w obrbie wywietlanej mapy bitowej. Pooenie tego obszaru jest liczone wzgldem
lewego dolnego rogu mapy bitowej.
:p.Przesunity obszar w obrbie mapy mapy bitowej naley narysowa w oknie, wewntrz obszaru
okrelonego wsprzdnymi przekazanymi w strukturze :hp1.bound:ehp1.. Dziki
tej manimpulacji, zachowana zostaje cigo rysowanego ta podczas przewijania
zawartoci okna.
:p.Rysowanie mona przeprowadzi za pomoc funkcji GpiWCBitBlt.
:p.Okna ktre nie obsuguj pola :hp1.refpoint:ehp1. powinny ustawi obydwie wsprzdne
rwne 0.
:edl.





.* Rozdzia 2.2 - Wewntrzne struktury danych
.*
:h2 res=022.Wewntrzne struktury danych
:p.Rozdzia zawiera opis struktur danych wykorzystywanych przez
modu asuactl.dll, niedostpnych dla uytkownika. Programista dodajcy
now kontrolk moe jednak z nich korzysta.



.* Struktura CTLREG
.*
:h3 name=CTLREG.CTLREG
:p.Struktura ta uywana jest przez funkcj
:link reftype=hd refid=ASUQUERYCTLINFO.AsuQueryCtlInfo:elink.,
przekazujc dane dotyczce okna kontrolnego do moduu asuactl.c.
Obecnie zawiera ona pola dajce moliwo odczytu wersji okna kontrolnego.

:cgraphic.
typedef struct
{ ULONG   :link dependent reftype=hd refid=CTL_CBSIZE.cbSize;:elink.        // Rozmiar
  PSZ     :link dependent reftype=hd refid=CTL_RCSVER.szRCSVersion;:elink.  // Numer wersji w ormacie RCS
  USHORT  :link dependent reftype=hd refid=CTL_VMAJOR.usVerMajor;:elink.    // Gwny numer wersji
  USHORT  :link dependent reftype=hd refid=CTL_VMINOR.usVerMinor;:elink.    // Dodatkowy numer wersji
} CTLINFO;
:ecgraphic.

.* Pole cbSize
.*
:h3 group=20 x=30% y=bottom width=70% height=225x hide name=CTL_CBSIZE.CTLINFO pole - cbSize
:dl tsize=3 break=all.
:dt.:hp2.cbSize:ehp2. (ULONG)
:dd.Pole to powinno zawiera liczb bajtw obejmujc pola, ktrych warto
ma zosta odczytana.
.br
Zaleca si uycie nastpujcego kodu:
:cgraphic.
ctl.cbSize = sizeof(CTLINFO);
:ecgraphic.
:edl.


.* Pole szRCSVersion
.*
:h3 group=21 x=30% y=bottom width=70% height=225x hide name=CTL_RCSVER.CTLINFO pole - szRCSVersion
:dl tsize=3 break=all.
:dt.:hp2.szRCSVersion:ehp2. (PSZ)
:dd.Pole to powinno zawiera wskanik do acucha tekstowego, nastpujcej postaci:
.br
:hp1."dowolny tekst x.y":ehp1., gdzie&colon. :hp2.x:ehp2. to gwny numer wersji, a :hp2.y:ehp2.
to numer podwersji. Gdy korzystamy z RCS-a, moe to wyglda nastpujco:
:cgraphic.
ctl.szRCSVersion = "$Revision 1.4 $";
:ecgraphic.
:p.Aby odczyt przebieg poprawnie, pola :hp1.usVerMajor:ehp1. i :hp1.usVerMinor:ehp1.
struktury CTLINFO powinny by rwne 0. W przeciwnym wypadku ich zawarto zastpi
informacje zawarte w polu :hp1.szRCSVersion:ehp1..
:p.W podanym przykadzie, wartoci zwracane przez funkcj
:link reftype=hd refid=ASUGETCOMPVER.AsuGetComponentVersion:elink.
bd nastpujce:
:dl tsize=25 break=none compact.
:dt.gwny numer wersji:
:dd.1,
:dt.numer podwersji:
:dd.40,
:edl.
:p.co naley czyta jako wersj 1.4.
:edl.



.* Pole usVerMajor
.*
:h3 group=22 x=30% y=bottom width=70% height=225x hide name=CTL_VMAJOR.CTLINFO pole - usVerMajor
:dl tsize=3 break=all.
:dt.:hp2.usVerMajor:ehp2. (USHORT)
:dd.Pole to powinno zawiera gwny numer wersji, np. 1, 2, itp.
:edl.


.* Pole ulVerMinor
.*
:h3 group=23 x=30% y=bottom width=70% height=225x hide name=CTL_VMINOR.CTLINFO pole - usVerMinor
:dl tsize=3 break=all.
:dt.:hp2.usVerMinor:ehp2. (USHORT)
:dd.Pole to powinno zawiera numer podwersji. Jeeli przykadowo, pole :hp1.usVerMajor:ehp1.
zawiera 2, to w zalenoci od zawartci pola :hp1.usVerMinor:ehp1. peny numer wersji
zwracany przez
:link reftype=hd refid=ASUGETCOMPVER.AsuGetComponentVersion:elink.
powinien by interpretowny w nastpujcy sposb&colon.
:dl tsize=25 break=none compact.
:dthd.:hp2.usVerMinor:ehp2.
:ddhd.:hp2.Numer wersji:ehp2.
:dt.1
:dd.2.01
:dt.10
:dd.2.1
:dt.15
:dd.2.15
:edl.
:edl.






:h3 name=PPTEMPLATE.PPTEMPLATE
:p.Struktura uywana jest przez funkcje
:link reftype=hd refid=PPMQUERYPRESCOLORS.PpmQueryPresColors:elink. i
:link reftype=hd refid=PPMSTOREPRESPARAMS.PpmStorePresParams:elink..
Zawiera ona list parametrw prezentacji okna, na ktrych dokonywane
s manipulacje.

:cgraphic.
typedef struct
{ ULONG :link dependent reftype=hd refid=PPT_ULPRESPARAM.ulPresParam:elink.;     // Identyfikator parametru prezentacji
  ULONG :link dependent reftype=hd refid=PPT_ULPRESFLAGS.ulPresFlags:elink.;     // Opcje QPF_* uywane przez funkcj WinQueryPresParam
  ULONG :link dependent reftype=hd refid=PPT_ULSYSCOLOR.ulSysColor:elink.;      // Indeks SYSCLR_* koloru systemowego
  ULONG :link dependent reftype=hd refid=PPT_ULRGBCOLOR.ulRgbColor:elink.;      // Domylny Kolor przypisany parametrowi prezentacji
} PPTEMPLATE;
:ecgraphic.

.* Pole ulPresParam
.*
:h3 group=20 x=30% y=bottom width=70% height=225x hide name=PPT_ULPRESPARAM.PPTEMPLATE pole - ulPresParam
:dl tsize=3 break=all.
:dt.:hp2.ulPresParam:ehp2. (ULONG)
:dd.Pole to, zawiera identyfikator parametru przezentacji, ktry ma by uwzgldniony
przez funkcje - zapamitany w pamici okna, lub z niej odczytany.
:edl.


.* Pole ulPresFlags
.*
:h3 group=21 x=30% y=bottom width=70% height=225x hide name=PPT_ULPRESFLAGS.PPTEMPLATE pole - ulPresFlags
:dl tsize=3 break=all.
:dt.:hp2.ulPresFlags:ehp2. (ULONG)
:dd.Pole to zawiera opcje przekazywane funkcji WinQueryPresParam, ktre pozwalaj
okreli, czy na przykad parametr prezentacji ma by dziedziczony. Dopuszczalne s
nastpujce opcje&colon.

:dl tsize=6 break=all.
:dt.QPF_NOINHERIT
:dd.Odczytywany parametr prezentacji nie jest dziedziczony po wacicielu
okna korzystajcego z funkcji
:link reftype=hd refid=PPMQUERYPRESCOLORS.PpmQueryPresColors:elink..
Gdy opcja nie jest uyta - parametr jest dziedziczony.
:dt.QPF_ID1COLORINDEX
:dd.Opcja powinna by uyta wtedy, gdy w polu ulPresParam struktury PPTEMPLATE
zdefiniowano parametr prezentacji bdcy indeksem odczytywanego koloru
(np. PP_BACKGROUNDCOLORINDEX zamiast PP_BACKGROUNDCOLOR).
:dt.QPF_ID2COLORINDEX
:dd.Opcja nie powinna by uywana.
:dt.QPF_PURERGBCOLOR
:dd.Opcja wymusza odczyt czystego koloru RGB, nie podlegajcego ditheringowi.
:edl.
:edl.



.* Pole ulSysColor
.*
:h3 group=22 x=30% y=bottom width=70% height=225x hide name=PPT_ULSYSCOLOR.PPTEMPLATE pole - ulSysColor
:dl tsize=3 break=all.
:dt.:hp2.ulSysColor:ehp2. (ULONG)
:dd.Pole to jest wykorzystywane przez funkcj
:link reftype=hd refid=PPMQUERYPRESCOLORS.PpmQueryPresColors:elink.
wtedy gdy odczyt parametru prezentacji nie powiedzie si.
:p.Odczytywany jest wwczas kolor systemowy SYSCLR_* o indeksie zdefiniowanym
w polu :hp1.ulSysColor:ehp1..
:edl.


.* Pole ulRgbColor
.*
:h3 group=23 x=30% y=bottom width=70% height=225x hide name=PPT_ULRGBCOLOR.PPTEMPLATE pole - ulRgbColor
:dl tsize=3 break=all.
:dt.:hp2.ulRgbColor:ehp2. (ULONG)
:dd.Pole to jest wykorzystywane przez funkcj
:link reftype=hd refid=PPMQUERYPRESCOLORS.PpmQueryPresColors:elink.
wtedy gdy pole :hp1.ulSysColor:ehp1. zawiera 0. W sytuacji takiej, funkcja
:link reftype=hd refid=PPMQUERYPRESCOLORS.PpmQueryPresColors:elink.
zwraca kolor RGB odczytany z :hp1.ulRgbColor:ehp1..
:edl.






.* Rozdzia 2.3 - Zmienne globalne
.*
:h2 res=023.Zmienne globalne.
:p.Rozdzia zawiera opis zmiennych globalnych udostpnianych programicie
piszcemu okna kontrolne przez funkcje inicjujce bibliotek dynamiczn.
:p.Wykorzystanie



.* Zmienna hResource
.*
:h3 name=HRESOURCE.hResource
:p.Jest to uchwyt bilioteki asuactl.dll, z ktrego mog korzysta kontrolki w celu
uzyskania dostpu np. do zasobw doczonych do DLL-a. Zmienna jest inicjowana
podczas adowania biblioteki do pamici.
:p.Zmienna jest zdefiniowana w pliku *.h nastpujco&colon.
:cgraphic.
extern HMODULE hResource;
:ecgraphic.



.* Zmienna hResource
.*
:h3 name=ULWARPVER.ulWarpVer
:p.Zmienna ta zawiera wersj systemu operacyjnego. Jst ona inicjowana
podczas adowania biblioteki do pamici.
:p.Zmienna jest zdefiniowana w pliku *.h nastpujco&colon.
:cgraphic.
extern ULONG ulWarpVer;
:ecgraphic.
:p.W zalenoci od wersji systemu zawiera ona nastpujce wartoci&colon.
:table cols='10 20'.
:row.:c.ulWarpVer:c.Wersja systemu&colon.
:row.:c.00:c.OS/2 2.0
:row.:c.10:c.OS/2 2.1
:row.:c.11:c.OS/2 2.11
:row.:c.30:c.OS/2 3.0
:row.:c.40:c.OS/2 4.0
:etable.

